﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Net.Http;
using System.Web;
using System.Web.Http.Controllers;
using System.Web.Http.Dispatcher;
using System.Web.Mvc;
using System.Web.Routing;
using Games.Web.Controllers;
using Games.Web.DataProviders;

namespace Games.Web
{
    public class GamesControllerActivator : IControllerActivator
    {
        public IController Create(RequestContext requestContext, Type controllerType)
        {
            IController controller;

            try
            {
                controller = (IController)DependencyResolver.Current.GetService(controllerType);
            }
            catch (Exception ex)
            {
                throw new InvalidOperationException($"Error creating controller of type {controllerType}", ex);
            }

            var baseGameController = controller as BaseGamesController;
            if (baseGameController != null)
            {
                baseGameController.GamesDataProvider = new GamesDbContext();
            }

            return controller;
        }
    }
}