﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using AutoMapper;
using Games.Entities;
using Games.Web.Models.Games;

namespace Games.Web
{
    public class MappingConfig
    {
        public static void RegisterMappings()
        {
            Mapper.CreateMap<Game, GameWithoutIdViewModel>()
                .ForMember(view => view.Name, options => options.MapFrom(game => game.Name))
                .ForMember(view => view.PublishedOn, options => options.MapFrom(game => game.PublishedOn))
                .ForMember(view => view.Genre, options => options.MapFrom(game => game.Genre));

            Mapper.CreateMap<GameWithoutIdViewModel, Game>()
               .ForMember(game => game.Name, options => options.MapFrom(view => view.Name))
               .ForMember(game => game.PublishedOn, options => options.MapFrom(view => view.PublishedOn))
               .ForMember(game => game.Genre, options => options.MapFrom(view => view.Genre));

            Mapper.CreateMap<Game, GameViewModel>()
                .ForMember(view => view.Id, options => options.MapFrom(game => game.Id))
                .ForMember(view => view.Name, options => options.MapFrom(game => game.Name))
                .ForMember(view => view.PublishedOn, options => options.MapFrom(game => game.PublishedOn))
                .ForMember(view => view.Genre, options => options.MapFrom(game => game.Genre));

            Mapper.CreateMap<GameViewModel, Game>()
               .ForMember(game => game.Id, options => options.MapFrom(view => view.Id))
               .ForMember(game => game.Name, options => options.MapFrom(view => view.Name))
               .ForMember(game => game.PublishedOn, options => options.MapFrom(view => view.PublishedOn))
               .ForMember(game => game.Genre, options => options.MapFrom(view => view.Genre));
        }
    }
}