﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Routing.Constraints;
using System.Web.Routing;

namespace Games.Web
{
    public class RouteConfig
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                name: "number",
                url: "Constraint/{number}",
                defaults: new { controller = "Constraint", action = "Number" },
                constraints: new { number = new IntRouteConstraint() }
            );

            routes.MapRoute(
                name: "string",
                url: "Constraint/{string}",
                defaults: new { controller = "Constraint", action = "String" }
            );

            routes.MapRoute(
                name: "ID",
                url: "{controller}/{action}/{id}",
                defaults: new { controller = "Home", action = "Index" },
                constraints : new { id = new GuidRouteConstraint() }
            );

            routes.MapRoute(
                name: "Default",
                url: "{controller}/{action}",
                defaults: new { controller = "Home", action = "Index" }
            );
        }
    }
}
