﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using Games.Entities;

namespace Games.Web.Models.Games
{
    public class GameWithoutIdViewModel : IValidatableObject
    {
        [Required]
        [Display(Name = "Title")]
        public string Name { get; set; }

        [DataType(DataType.Date)]
        [Display(Name = "Published")]
        public DateTime? PublishedOn { get; set; }

        [Display(Name = "Genre")]
        [EnumDataType(typeof(GameGenreEnum))]
        public GameGenreEnum Genre { get; set; }

        public IEnumerable<ValidationResult> Validate(ValidationContext validationContext)
        {
            if (PublishedOn.HasValue)
            {
                if (PublishedOn.Value.Year < 1950)
                {
                    yield return new ValidationResult("Year too far in the past");
                }
            }
        }
    }
}